<a id="mypy-boto3-kafkaconnect"></a>

# mypy-boto3-kafkaconnect

[![PyPI - types-aiobotocore-kafkaconnect](https://img.shields.io/pypi/v/types-aiobotocore-kafkaconnect.svg?color=blue)](https://pypi.org/project/types-aiobotocore-kafkaconnect)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-kafkaconnect.svg?color=blue)](https://pypi.org/project/types-aiobotocore-kafkaconnect)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-kafkaconnect?color=blue)](https://pypistats.org/packages/types-aiobotocore-kafkaconnect)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.KafkaConnect 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/kafkaconnect.html#KafkaConnect)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-kafkaconnect docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_kafkaconnect/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-kafkaconnect](#mypy-boto3-kafkaconnect)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `KafkaConnect`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `KafkaConnect` service.

```bash
python -m pip install types-aiobotocore[kafkaconnect]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[kafkaconnect]` in your environment:
  `python -m pip install 'types-aiobotocore[kafkaconnect]'`

Both type checking and auto-complete should work for `KafkaConnect` service. No
explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[kafkaconnect]` in your environment:
  `python -m pip install 'types-aiobotocore[kafkaconnect]'`

Both type checking and auto-complete should work for `KafkaConnect` service. No
explicit type annotations required, write your `aiobotocore` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[kafkaconnect]` in your environment:
  `python -m pip install 'types-aiobotocore[kafkaconnect]'`
- Run `mypy` as usual

Type checking should work for `KafkaConnect` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[kafkaconnect]` in your environment:
  `python -m pip install 'types-aiobotocore[kafkaconnect]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `KafkaConnect` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`KafkaConnectClient` provides annotations for
`session.create_client("kafkaconnect")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_kafkaconnect import KafkaConnectClient

session = get_session()
with async session.create_client("kafkaconnect") as client:
    client: KafkaConnectClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_kafkaconnect.paginator` module contains type annotations for
all paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_kafkaconnect import KafkaConnectClient
from types_aiobotocore_kafkaconnect.paginator import (
    ListConnectorsPaginator,
    ListCustomPluginsPaginator,
    ListWorkerConfigurationsPaginator,
)

session = get_session()
with async session.create_client("kafkaconnect") as client:
    client: KafkaConnectClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_connectors_paginator: ListConnectorsPaginator = client.get_paginator("list_connectors")
        list_custom_plugins_paginator: ListCustomPluginsPaginator = client.get_paginator("list_custom_plugins")
        list_worker_configurations_paginator: ListWorkerConfigurationsPaginator = client.get_paginator("list_worker_configurations")
    ```







### Literals

`types_aiobotocore_kafkaconnect.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_kafkaconnect.literals import (
    ConnectorStateType,
    CustomPluginContentTypeType,
    CustomPluginStateType,
    KafkaClusterClientAuthenticationTypeType,
    KafkaClusterEncryptionInTransitTypeType,
    ListConnectorsPaginatorName,
    ListCustomPluginsPaginatorName,
    ListWorkerConfigurationsPaginatorName,
    ServiceName,
    PaginatorName,
)

def check_value(value: ConnectorStateType) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_kafkaconnect.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_kafkaconnect.type_defs import (
    ApacheKafkaClusterDescriptionTypeDef,
    ApacheKafkaClusterTypeDef,
    AutoScalingDescriptionTypeDef,
    AutoScalingTypeDef,
    AutoScalingUpdateTypeDef,
    CapacityDescriptionTypeDef,
    CapacityTypeDef,
    CapacityUpdateTypeDef,
    CloudWatchLogsLogDeliveryDescriptionTypeDef,
    CloudWatchLogsLogDeliveryTypeDef,
    ConnectorSummaryTypeDef,
    CreateConnectorRequestRequestTypeDef,
    CreateConnectorResponseTypeDef,
    CreateCustomPluginRequestRequestTypeDef,
    CreateCustomPluginResponseTypeDef,
    CreateWorkerConfigurationRequestRequestTypeDef,
    CreateWorkerConfigurationResponseTypeDef,
    CustomPluginDescriptionTypeDef,
    CustomPluginFileDescriptionTypeDef,
    CustomPluginLocationDescriptionTypeDef,
    CustomPluginLocationTypeDef,
    CustomPluginRevisionSummaryTypeDef,
    CustomPluginSummaryTypeDef,
    CustomPluginTypeDef,
    DeleteConnectorRequestRequestTypeDef,
    DeleteConnectorResponseTypeDef,
    DescribeConnectorRequestRequestTypeDef,
    DescribeConnectorResponseTypeDef,
    DescribeCustomPluginRequestRequestTypeDef,
    DescribeCustomPluginResponseTypeDef,
    DescribeWorkerConfigurationRequestRequestTypeDef,
    DescribeWorkerConfigurationResponseTypeDef,
    FirehoseLogDeliveryDescriptionTypeDef,
    FirehoseLogDeliveryTypeDef,
    KafkaClusterClientAuthenticationDescriptionTypeDef,
    KafkaClusterClientAuthenticationTypeDef,
    KafkaClusterDescriptionTypeDef,
    KafkaClusterEncryptionInTransitDescriptionTypeDef,
    KafkaClusterEncryptionInTransitTypeDef,
    KafkaClusterTypeDef,
    ListConnectorsRequestRequestTypeDef,
    ListConnectorsResponseTypeDef,
    ListCustomPluginsRequestRequestTypeDef,
    ListCustomPluginsResponseTypeDef,
    ListWorkerConfigurationsRequestRequestTypeDef,
    ListWorkerConfigurationsResponseTypeDef,
    LogDeliveryDescriptionTypeDef,
    LogDeliveryTypeDef,
    PaginatorConfigTypeDef,
    PluginDescriptionTypeDef,
    PluginTypeDef,
    ProvisionedCapacityDescriptionTypeDef,
    ProvisionedCapacityTypeDef,
    ProvisionedCapacityUpdateTypeDef,
    ResponseMetadataTypeDef,
    S3LocationDescriptionTypeDef,
    S3LocationTypeDef,
    S3LogDeliveryDescriptionTypeDef,
    S3LogDeliveryTypeDef,
    ScaleInPolicyDescriptionTypeDef,
    ScaleInPolicyTypeDef,
    ScaleInPolicyUpdateTypeDef,
    ScaleOutPolicyDescriptionTypeDef,
    ScaleOutPolicyTypeDef,
    ScaleOutPolicyUpdateTypeDef,
    UpdateConnectorRequestRequestTypeDef,
    UpdateConnectorResponseTypeDef,
    VpcDescriptionTypeDef,
    VpcTypeDef,
    WorkerConfigurationDescriptionTypeDef,
    WorkerConfigurationRevisionDescriptionTypeDef,
    WorkerConfigurationRevisionSummaryTypeDef,
    WorkerConfigurationSummaryTypeDef,
    WorkerConfigurationTypeDef,
    WorkerLogDeliveryDescriptionTypeDef,
    WorkerLogDeliveryTypeDef,
)

def get_structure() -> ApacheKafkaClusterDescriptionTypeDef:
    return {
      ...
    }
```

## Versioning

`types-aiobotocore-kafkaconnect` version is the same as related `boto3` version
and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

## Documentation

All type annotations can be found in
[types-aiobotocore-kafkaconnect docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_kafkaconnect/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
